package com.zehong.system.modbus.handler;

import com.zehong.system.modbus.business.DeviceStatusReaderAndTimeSetter;
import com.zehong.system.modbus.dto.DeviceStatusReaderDto;

import java.util.Arrays;
import java.util.function.Consumer;
import java.util.function.Predicate;

/**
 * @author lenovo
 * @date 2025/6/27
 * @description TODO
 */
public class ModbusResultHandler implements Consumer<DeviceStatusReaderDto> {
    @Override
    public void accept(DeviceStatusReaderDto deviceStatusReaderDto) {

        int deviceId = deviceStatusReaderDto.getDeviceId();
        int[] data = deviceStatusReaderDto.getRegisterData();
        String ip = deviceStatusReaderDto.getIp();
        int port = deviceStatusReaderDto.getPort();

        System.out.println(">>> 回调处理: 接收到新数据");
        System.out.println("    数据: " + Arrays.toString(data));

        if (data.length >= 2 && data[1] == DeviceStatusReaderAndTimeSetter.TARGET_VALUE) {
            System.out.println("    >>> 注意: 第二个寄存器值为1!");
        }
    }

    // 创建通用的停止条件（可选）
    public static Predicate<int[]> createDefaultStopCondition() {
        return values -> values.length >= 2 && values[1] == DeviceStatusReaderAndTimeSetter.TARGET_VALUE;
    }
}
